$crystal = 8000000
$regfile = "attiny85.dat"
'$regfile = "attiny45.dat"
'$regfile = "attiny25.dat"
$hwstack = 32
$swstack = 8
$framesize = 32

Const I2c_slave_address = &B11110000                        'define this slave write address
Const I2c_bytes_to_receive = 3                              'define number of bytes to receive
Const I2c_bytes_to_send = 0                                 'define number of bytes to send

I2c_port Alias Portb
I2c_pin Alias Pinb
Const Scl = 2                                               'PB.2 = SCL
Const Sda = 0                                               'PB.0 = SDA

Config Clockdiv = 1

$include Attiny_i2cslave_usi.sub                            'include main program that uses usi
'$include Attiny_i2cslave_usi_bascom.sub                     'include main program that uses usi&Bascom
'$include Attiny_i2cslave_nousi.sub                          'include main program that uses no usi

'================ User subroutines ================

Init_slave:                                                 'This sub will be executed before the main program loop
'R = OC1A (PB1)
'G = OCR0A, OCR0B (PB3, int)
'B = OC1B (PB4)

  Const Rgb_common_ac = "a"                                 'RGB with common anode (=a) or cathode (=c)

  Config Portb.1 = Output
  Config Portb.3 = Output
  Config Portb.4 = Output

  Ocr0a = 0
  Ocr0b = 255
  Ocr1a = 0
  Ocr1b = 0
  Ocr1c = 255

  On Compare0a Tim0_compa_sub Nosave
  On Compare0b Tim0_compb_sub Nosave

  Enable Compare0a
  Enable Compare0b
  Enable Interrupts

  Config Timer0 = Timer , Prescale = 64

  Tccr1 = &B01110111                                        'Timer1 = Pwm , Prescale = 64 , on CompareC reset OC1A, OC1B
  Gtccr = &B01110000                                        'on CompareA set OC1A, on CompareB set OC1B

  Gosub Rgb_demo
Return

Prepare_data_to_be_sent:                                    'This sub will be executed before data will be sent to the master
Return

Execute_i2c_command:                                        'This sub will be executed when data or command has been received from the master
#if Rgb_common_ac = "a"
  Ocr1a = I2c_rcv_byte(1)
  If I2c_rcv_byte(2) = 0 Then
    Stop Timer0
    Set Portb.3
  Else
    Ocr0a = I2c_rcv_byte(2)
    Start Timer0
  End If
  Ocr1b = I2c_rcv_byte(3)
#elseif
  Ocr1a = Not I2c_rcv_byte(1)
  If I2c_rcv_byte(2) = 0 Then
    Stop Timer0
    Reset Portb.3
  Else
    Ocr0a = Not I2c_rcv_byte(2)
    Start Timer0
  End If
  Ocr1b = Not I2c_rcv_byte(3)
#endif
Return

Tim0_compa_sub:
  Set Portb.3
Return

Tim0_compb_sub:
  Reset Portb.3
Return

Rgb_demo:
  For I2c_rcv_byte(1) = 0 To 255
    Gosub Execute_i2c_command
    Waitms 2
  Next
  For I2c_rcv_byte(1) = 255 To 1 Step -1
    Gosub Execute_i2c_command
    Waitms 2
  Next
  For I2c_rcv_byte(2) = 0 To 255
    Gosub Execute_i2c_command
    Waitms 2
  Next
  For I2c_rcv_byte(2) = 255 To 1 Step -1
    Gosub Execute_i2c_command
    Waitms 2
  Next
  For I2c_rcv_byte(3) = 0 To 255
    Gosub Execute_i2c_command
    Waitms 2
  Next
  For I2c_rcv_byte(3) = 255 To 1 Step -1
    Gosub Execute_i2c_command
    Waitms 2
  Next
  For I2c_rcv_byte(1) = 0 To 255
    I2c_rcv_byte(2) = I2c_rcv_byte(1)
    I2c_rcv_byte(3) = I2c_rcv_byte(1)
    Gosub Execute_i2c_command
    Waitms 2
  Next
  For I2c_rcv_byte(1) = 255 To 0 Step -1
    I2c_rcv_byte(2) = I2c_rcv_byte(1)
    I2c_rcv_byte(3) = I2c_rcv_byte(1)
    Gosub Execute_i2c_command
    Waitms 2
  Next
Return